package View;

import static android.app.PendingIntent.getActivity;

import android.annotation.SuppressLint;
import android.app.TimePickerDialog;
import android.os.Bundle;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.example.habittracker.R;

import java.util.Calendar;

import Database.DatabaseHelper;
import Model.Habit;

public class AddHabit extends AppCompatActivity {
    Button timePicker;
    TextView selectedTimeTv;
    EditText newHabitEt;
    String selectedTime;
    DatabaseHelper db;
    Button addHabitBtn;
    Button backBtn;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_add_habit);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        timePicker = findViewById(R.id.time_picker);
        addHabitBtn = findViewById(R.id.add_new_habit_btn);
        backBtn = findViewById(R.id.back_btn);
        selectedTimeTv = findViewById(R.id.selected_time_tv);
        newHabitEt = findViewById(R.id.new_habit_et);
        db = new DatabaseHelper(AddHabit.this);

        timePicker.setOnClickListener(v -> {
            Calendar calendar = Calendar.getInstance();
            int hour = calendar.get(Calendar.HOUR_OF_DAY);
            int minute = calendar.get(Calendar.MINUTE);

            // Show TimePickerDialog
            @SuppressLint("DefaultLocale") TimePickerDialog timePickerDialog = new TimePickerDialog(
                    AddHabit.this,
                    (view, hourOfDay, minuteOfHour) -> {
                        // Update the TextView with the selected time
                        selectedTime = String.format("%02d:%02d", hourOfDay, minuteOfHour);
                        selectedTimeTv.setText(selectedTime);
                    },
                    hour,
                    minute,
                    true // Set to true for 24-hour format, false for AM/PM
            );
            timePickerDialog.show();
        });

        addHabitBtn.setOnClickListener(v -> {
               boolean result = db.createHabit(new Habit(HomeActivity.userId, newHabitEt.getText().toString(), selectedTime));
               if(result) {
                   Toast.makeText(this, "Habit added successfully", Toast.LENGTH_SHORT).show();
               }else {
                   Toast.makeText(this, "Error adding habit", Toast.LENGTH_SHORT).show();
               }
        });

        backBtn.setOnClickListener(v -> {
            finish();
        });
    }



}
