package View;

import static android.util.Log.println;

import android.os.Bundle;
import android.util.Log;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.example.habittracker.R;

import Database.DatabaseHelper;
import Model.User;

public class CreateAccountActivity extends AppCompatActivity {

    EditText usernameEt;
    EditText passwordEt;
    Button createAccountBtn;
    Button backBtn;
    DatabaseHelper db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_create_account);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        usernameEt = findViewById(R.id.username_et);
        passwordEt = findViewById(R.id.password_et);
        createAccountBtn = findViewById(R.id.create_account_btn);
        backBtn = findViewById(R.id.back_btn);
        db = new DatabaseHelper(CreateAccountActivity.this);

        createAccountBtn.setOnClickListener(v -> {
            //Test
            println(Log.DEBUG, "username: ", usernameEt.getText().toString());
            println(Log.DEBUG, "password: ", passwordEt.getText().toString());

            //User creation
            if(formValidate()) {
                //Logic to create the user and store in the DB
                User user = new User(usernameEt.getText().toString(), passwordEt.getText().toString());

                try {
                    boolean result = db.createAccount(user);
                    Toast.makeText(this, "Account creation successful = " + result, Toast.LENGTH_SHORT).show();

                }catch (Exception e) {
                    Toast.makeText(this, "Error creating account", Toast.LENGTH_SHORT).show();
                }
            }
        });


        backBtn.setOnClickListener(v -> {
            //Go back to login
            finish();
        });


    }

    //Method for form validation
    private boolean formValidate() {

        if (usernameEt.getText().toString().isEmpty()|| passwordEt.getText().toString().isEmpty()) {
            Toast.makeText(this, "Please fill in all fields", Toast.LENGTH_SHORT).show();
            return false;
        }
        return true;
    }
}